ctools - Bug #1415

errors with ctobssim simulation for diffuse source with Healpix file
02/03/2015 01:57 PM - Yang Lili

Status: Closed Start date: 02/03/2015
Priority: Normal Due date:

Assigned To: Knédlseder Jurgen % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 1.0.0

Description

Use ctobssim for CTA simulation for diffuse sources with Healpix fits file, get the following error:

terminate called after throwing an instance of 'GException::invalid_argument'

what(): *** ERROR in GSkymap::pix2dir(GSkyPixel&): Invalid argument.

A 2-dimensional sky map pixel (298.425,-0.374402) is used to determine the sky direction for the 1-dimensional sky projection
"HealPix"

Please specify a 1-dimensional sky map pixel.

Aborted (core dumped)

History

#1 - 02/03/2015 03:02 PM - Knodlseder Jiirgen
- Assigned To set to Knédlseder Jiirgen

- Target version set to 1.0.0

Just for the record:

e Gammalib needs the ORDERING keyword, the original file had a ORDER keyword. | should check whether both are "standard"

¢ GammalLib needs the PIXTYPE keyword set to Healpix. Also should check if this is standard or if some other way should be okay to identify
whether a file is Healpix.

e GammalLib needs the COORDSYS keyword to know in which coordinate system the map is given. | see no real way around that problem.

Finally, | should put somewhere information about the expected HealPix format so that people can look up what is needed.

#2 - 02/03/2015 06:00 PM - Knodlseder Jiirgen
- Status changed from New to In Progress

- % Done changed from 0 to 10

Unfortunately there is some way to go as the actual code has been mainly geared towards WCS maps and not to the usage of HealPix maps.
So far | have identified the following:

e The GModelSpatialDiffuseMap::mc needs to be adapted to work also on HealPix maps. | have some code working but | cannot yet make sense
of the results. | first need to produce a test case.

¢ The GSkymap::operator() sky direction operator is only implemented for WCS maps, HealPix does not work. This operator is needed for
interpolating within a map. Implementation of this operator for HealPix needs nearest neighbour pixel determination, which in principle is easy in
HealPix, but needs some reading to understand how to do it properly
#3 - 02/04/2015 12:45 AM - Knddlseder Jiirgen
- File diffuse_src.xml added

- File map_car_gal.fits added

- % Done changed from 10 to 80

Both issues have been fixed. The GSkymap::operator() sky direction operator now also works for HealPix maps, a working example is the conversion
from HealPix into another projection:

$ python

>>> import gammalib

>>> healpix=gammalib.GSkymap("healpix.fits")

>>> map=gammalib.GSkymap("CAR","GAL",0.0,0.0,0.5,0.5,720,360)
>>> map += healpix

>>> map.save("map_car_gal.fits", True)

This code projects the HealPix map into a cartesian map and saves the result on disk.

The GModelSpatialDiffuseMap::mc has also been adapted. A working example is:

$ ctobssim

RA of pointing (degrees) (0-360) [128.84]

Dec of pointing (degrees) (-90-90) [-45.18]
Radius of FOV (degrees) (0-180) [20.0]

Start time (MET in s) (0) [0.0]

End time (MET in s) (0) [1800.0]

Lower energy limit (TeV) (0) [0.1]

Upper energy limit (TeV) (0) [100.0]
Calibration database [dummy]

Instrument response function [cta_dummy_irf]
Model [diffuse_src.xml]

Output event data file or observation definition file [events.fits]

using the attached XML file that contains only the source component. The intensity of the map has been changed so that a few 100 events get
simulated. The simulation region is centred on Vela, the brightest source in the map. The simulated events obviously cluster around Vela.

Some more testing is needed to validate all changes.
#4 - 02/04/2015 08:23 AM - Yang Lili
- File wes.fits added

Thanks for your effort!! | think it would be good if you also put some information about what is needed for WCS format file. | am trying a wcs fits file
with ctobssim, it gives the following errors,

e ERROR encounterted in the execution of ctobssim. Run aborted ...
* ERROR in GSkymap::alloc_wcs(GFitsimage*): Invalid World Coordinate System code (MOL). Projection code not known. Should be one of
AIT/AZP/CAR/MER/TAN/STG.

Could you please indicate what is missing? Thank you in advance.

#5 - 02/04/2015 09:02 AM - Knddlseder Jiirgen
MOL is not yet supported. | will add support for this later.

#6 - 02/04/2015 10:32 AM - Knddlseder Jiirgen
- % Done changed from 80 to 90

| added the MOL projection (class GWcsMOL). Will be merged into devel within the next hour.

#7 - 02/04/2015 11:05 AM - KnddlIseder Jiirgen

Now merged into devel branch.
| created a follow-up action (#1416) to make sure that all missing WCS projections will be implemented at some point in time.

Is this issue now fixed from your side or do you still encounter problems somewhere?

#8 - 02/05/2015 04:36 PM - Yang Lili

Using ctobssim with wcs fits file, find this error,

e ERROR encounterted in the execution of ctobssim. Run aborted ...
* ERROR in GWcsMOL::prj_x2s(int, int, int, int, double*, double*, double*, double*, int*): 2 (x,y) coordinates were invalid.

#9 - 02/05/2015 06:15 PM - Knodlseder Jiirgen

Yang Lili wrote:
Using ctobssim with wcs fits file, find this error,

e ERROR encounterted in the execution of ctobssim. Run aborted ...
e ERROR in GWcsMOL::prj_x2s(int, int, int, int, double*, double*, double*, double*, int*): 2 (x,y) coordinates were invalid.

| think something is wrong with that map, | even get an error when | open the file with fv. | see that you have 721 x 361 pixels of 0.5 deg, hence
formally this map is bigger than the sky. | also see blank bands on the top and the bottom, which may indicate that these zones lie outside the range
of valid coordinates. | don't know how MOL is defined, but maybe you cannot map an entire sky with that projection.

Have you tried the original HealPix map with the next code? | guess it should work.
#10 - 02/05/2015 06:18 PM - KnédlIseder Jiirgen
- File wes_map.png added

DS9 says "Off map" for the zones at the top and the bottom. Hence | think that ctobssim says basically the same thing, just in other words.

(= NN &) - N S-A(}-I-rnage-dsg -

Fichier wes.fits

Objet

Value 0.000878893

WCS Off map o

Physigue X 229.000 Y 351.000 |

Image X 229.000 Y 351.000 _
Fenétre 1 Zoom 1.000 Angle 0.000

{ﬁchier} [ édition j [ affichage } { fenétre} bin {zcom ){ scale j [ couleur ) { région j [ WCs }{aide}
{ linéaire }E—Iuga{ puissance j[ sguare root j[ sguared }{ histogramme jfﬂnnrnmr}{ zscale }

0.000015 0.000023 0.000037 0.000065 0.000122 0.000235 0.000461 0.000915 0.001814
#11 - 02/05/2015 08:14 PM - Yang Lili

Have you tried the original HealPix map with the next code? | guess it should work.

Yes, | have tried that file. It works fine.

#12 - 10/27/2015 11:23 PM - KnddlIseder Jiirgen
- Status changed from In Progress to Closed

- % Done changed from 90 to 100

Close this now as problem was related to an invalid input map.

Files

healpix.fits 200 KB 02/03/2015 Yang Lili
diffuse.xml 1.06 KB 02/03/2015 Yang Lili
diffuse_src.xml 725 Bytes 02/03/2015 Knddlseder Jurgen
map_car_gal.fits 1.98 MB 02/03/2015 Knédlseder Jirgen
wcs.fits 1.99 MB 02/04/2015 Yang Lili
WCS_map.png 226 KB 02/05/2015 Knédlseder Jirgen
